//<c>   Copyright 1992-1999 by Gerry J. Danen; all rights reserved.

//<t>   List print queues

//      Compiled with Microsoft C 8.00. Requires DANEN library to recompile.
//      Source released into the Public Domain.

#include"gd_tools.h"
#include"gd_nw.h"
#include<nit.h>
#include<nitq.h>
#include<niterror.h>


#define pgVERS_ "V3.00"
#define pgTITL_ "NetWare Print Queue Status"
#define pgCOPR_ "1992"


static  STRING mname[] =
{
        "???",
        "Jan", "Feb", "Mar", "Apr", "May", "Jun",
        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};


void    usage( void )
{
    logon(1);
    printf(
        "\n%s lists jobs in Novell NetWare print queues.\n\n"
        "Syntax:  %s [server] [queue]\n\n"
        "The job's priority, name, size, user id, date & time queued, status,\n"
        "job number, and form type are displayed.\n\n"
        "If a [server] is not specified, the default server is used.\n"
        "If a [queue] is not specified, all queues will be displayed.\n\n",
        get_global_program_name(), get_global_program_name() );
    exit( BAD_EXIT );
}


void    main( int argc, char *argv[] )
{
    BYTE        printerHalted, printerOffLine;
    JobStruct   job;
    WORD        qcount, jnlist[250], cid;
    int         objtype, i, rc, targetPrinter, printerNumber, formType, qcntr, ob_type, errorcode;
    long        queueid, filesize;
    char        *qname, user[48], ob_name[48], ob_hasprop, ob_flag, ob_security;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    if ( argc > 3 )
        usage();

    if (argc == 1)
        qname = "*";
    else
    {
        qname = argv[1];
        if ( st_eq(qname,"?") || st_eq(qname,"/?") || st_eq(qname,"/h") )
            usage();
    }
    if ( argc == 3 )
    {
        qname = argv[2];
        _strupr( argv[1] );
        rc = GetConnectionID(argv[1], &cid);
        if ( ! rc && IsConnectionIDInUse(cid) )
        {
            SetPreferredConnectionID((BYTE) cid);
        }
        else
        {
            printf( "\nNot attached to server %s\n\n", argv[1] );
            usage();
        }
    }
    for ( printerNumber = 0 ; printerNumber < 5 ; printerNumber++ )
    {
        if ( GetPrinterStatus( printerNumber, &printerHalted, &printerOffLine, &formType, &targetPrinter ) == 0 )
        {
            if ( targetPrinter < 5 )
            {
                printf( "Printer %1d: ", printerNumber );
                if ( printerHalted )
                    printf( "Halted  " );
                else
                    printf( "Running " );
                if (printerOffLine)
                    printf( "Off-line " );
                else
                    printf( "On-line  " );
                if ( printerNumber != targetPrinter )
                    printf( "Routed to %d  ", targetPrinter );
                printf( "Form %d mounted\n", formType );
            }
        }
    }
    printf("\n");

    queueid = -1 ;
    _strupr( qname );
    qcntr = 0;
    errorcode = 0;
    while ( ! errorcode )
    {
        errorcode = ScanBinderyObject( qname, OT_PRINT_QUEUE, &queueid, ob_name, &ob_type, &ob_hasprop, &ob_flag, &ob_security );
        if ( errorcode )
        {
            if ( qcntr )
            {
                exit( GOOD_EXIT );
            }
            else
            {
                printf( "\nCannot find print queue %s\n\n", qname );
                usage();
            }
        }
        qcntr++;
        if ( GetQueueJobList(queueid, &qcount, jnlist, 10) )
        {
            printf( "Cannot get job list for print queue %s\n", ob_name );
        }
        else
        {
            if ( ! qcount )
            {
                printf( "No print jobs in queue %s\n", ob_name);
            }
            else
            {
                printf( "\nPrint Queue %s\n", ob_name);
                printf( "Priority Job Name           Size User            Queued       Status  Job Form\n");
                printf( "       \n");
                for ( i = 0 ; i < (int)qcount ; i++ )
                {
                    if ( ! ReadQueueJobEntry(queueid, jnlist[i], &job) )
                    {
                        printf( "%6d   ", job.jobPosition );
                        printf( "%-15.15s", job.textJobDescription );
                        GetQueueJobsFileSize(queueid, jnlist[i], &filesize);
                        printf( "%8ld ", filesize );
                        if ( ! GetBinderyObjectName(job.clientIDNumber, user, &objtype) )
                            printf( "%-15.15s", user );
                        else
                            printf( "%-15s", "*UNKNOWN*" );
                        printf( " %2d-%s %02d:%02d ",
                                job.jobEntryTime[2], mname[job.jobEntryTime[1]],
                                job.jobEntryTime[3], job.jobEntryTime[4] );
                        if ( job.jobControlFlags & (QF_USER_HOLD | QF_OPERATOR_HOLD) )
                            printf( "Hold  ");
                        else
                        if (job.jobControlFlags & QF_ENTRY_OPEN)
                            printf( "Adding");
                        else
                        if (job.serverIDNumber)
                            printf( "Active");
                        else
                        if (job.targetExecutionTime[0]==0xff)
                            printf( "Ready ");
                        else
                            printf( "Delay ");
                        printf( "%5d%4d\n", job.jobNumber, job.jobType );
                    }
                }
                printf("\n");
            }
        }
    }
    exit( GOOD_EXIT );
}
